test-lib-functions.sh: teach test_commit -C <dir>
[git/git.git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33 }
34
35 test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
45 if (n == 30) return "BLACK";
46 if (n == 31) return "RED";
47 if (n == 32) return "GREEN";
48 if (n == 33) return "YELLOW";
49 if (n == 34) return "BLUE";
50 if (n == 35) return "MAGENTA";
51 if (n == 36) return "CYAN";
52 if (n == 37) return "WHITE";
53 if (n == 40) return "BLACK";
54 if (n == 41) return "BRED";
55 if (n == 42) return "BGREEN";
56 if (n == 43) return "BYELLOW";
57 if (n == 44) return "BBLUE";
58 if (n == 45) return "BMAGENTA";
59 if (n == 46) return "BCYAN";
60 if (n == 47) return "BWHITE";
61 }
62 {
63 while (match($0, /\033\[[0-9;]*m/) != 0) {
64 printf "%s<", substr($0, 1, RSTART-1);
65 codes = substr($0, RSTART+2, RLENGTH-3);
66 if (length(codes) == 0)
67 printf "%s", name(0)
68 else {
69 n = split(codes, ary, ";");
70 sep = "";
71 for (i = 1; i <= n; i++) {
72 printf "%s%s", sep, name(ary[i]);
73 sep = ";"
74 }
75 }
76 printf ">";
77 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
78 }
79 print
80 }
81 '
82 }
83
84 lf_to_nul () {
85 perl -pe 'y/\012/\000/'
86 }
87
88 nul_to_q () {
89 perl -pe 'y/\000/Q/'
90 }
91
92 q_to_nul () {
93 perl -pe 'y/Q/\000/'
94 }
95
96 q_to_cr () {
97 tr Q '\015'
98 }
99
100 q_to_tab () {
101 tr Q '\011'
102 }
103
104 qz_to_tab_space () {
105 tr QZ '\011\040'
106 }
107
108 append_cr () {
109 sed -e 's/$/Q/' | tr Q '\015'
110 }
111
112 remove_cr () {
113 tr '\015' Q | sed -e 's/Q$//'
114 }
115
116 # In some bourne shell implementations, the "unset" builtin returns
117 # nonzero status when a variable to be unset was not set in the first
118 # place.
119 #
120 # Use sane_unset when that should not be considered an error.
121
122 sane_unset () {
123 unset "$@"
124 return 0
125 }
126
127 test_tick () {
128 if test -z "${test_tick+set}"
129 then
130 test_tick=1112911993
131 else
132 test_tick=$(($test_tick + 60))
133 fi
134 GIT_COMMITTER_DATE="$test_tick -0700"
135 GIT_AUTHOR_DATE="$test_tick -0700"
136 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
137 }
138
139 # Stop execution and start a shell. This is useful for debugging tests and
140 # only makes sense together with "-v".
141 #
142 # Be sure to remove all invocations of this command before submitting.
143
144 test_pause () {
145 if test "$verbose" = t; then
146 "$SHELL_PATH" <&6 >&3 2>&4
147 else
148 error >&5 "test_pause requires --verbose"
149 fi
150 }
151
152 # Wrap git in gdb. Adding this to a command can make it easier to
153 # understand what is going on in a failing test.
154 #
155 # Example: "debug git checkout master".
156 debug () {
157 GIT_TEST_GDB=1 "$@"
158 }
159
160 # Call test_commit with the arguments
161 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
162 #
163 # This will commit a file with the given contents and the given commit
164 # message, and tag the resulting commit with the given tag name.
165 #
166 # <file>, <contents>, and <tag> all default to <message>.
167 #
168 # If the first argument is "-C", the second argument is used as a path for
169 # the git invocations.
170
171 test_commit () {
172 notick= &&
173 signoff= &&
174 indir= &&
175 while test $# != 0
176 do
177 case "$1" in
178 --notick)
179 notick=yes
180 ;;
181 --signoff)
182 signoff="$1"
183 ;;
184 -C)
185 indir="$2"
186 shift
187 ;;
188 *)
189 break
190 ;;
191 esac
192 shift
193 done &&
194 indir=${indir:+"$indir"/} &&
195 file=${2:-"$1.t"} &&
196 echo "${3-$1}" > "$indir$file" &&
197 git ${indir:+ -C "$indir"} add "$file" &&
198 if test -z "$notick"
199 then
200 test_tick
201 fi &&
202 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
203 git ${indir:+ -C "$indir"} tag "${4:-$1}"
204 }
205
206 # Call test_merge with the arguments "<message> <commit>", where <commit>
207 # can be a tag pointing to the commit-to-merge.
208
209 test_merge () {
210 test_tick &&
211 git merge -m "$1" "$2" &&
212 git tag "$1"
213 }
214
215 # This function helps systems where core.filemode=false is set.
216 # Use it instead of plain 'chmod +x' to set or unset the executable bit
217 # of a file in the working directory and add it to the index.
218
219 test_chmod () {
220 chmod "$@" &&
221 git update-index --add "--chmod=$@"
222 }
223
224 # Unset a configuration variable, but don't fail if it doesn't exist.
225 test_unconfig () {
226 config_dir=
227 if test "$1" = -C
228 then
229 shift
230 config_dir=$1
231 shift
232 fi
233 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
234 config_status=$?
235 case "$config_status" in
236 5) # ok, nothing to unset
237 config_status=0
238 ;;
239 esac
240 return $config_status
241 }
242
243 # Set git config, automatically unsetting it after the test is over.
244 test_config () {
245 config_dir=
246 if test "$1" = -C
247 then
248 shift
249 config_dir=$1
250 shift
251 fi
252 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
253 git ${config_dir:+-C "$config_dir"} config "$@"
254 }
255
256 test_config_global () {
257 test_when_finished "test_unconfig --global '$1'" &&
258 git config --global "$@"
259 }
260
261 write_script () {
262 {
263 echo "#!${2-"$SHELL_PATH"}" &&
264 cat
265 } >"$1" &&
266 chmod +x "$1"
267 }
268
269 # Use test_set_prereq to tell that a particular prerequisite is available.
270 # The prerequisite can later be checked for in two ways:
271 #
272 # - Explicitly using test_have_prereq.
273 #
274 # - Implicitly by specifying the prerequisite tag in the calls to
275 # test_expect_{success,failure,code}.
276 #
277 # The single parameter is the prerequisite tag (a simple word, in all
278 # capital letters by convention).
279
280 test_set_prereq () {
281 satisfied_prereq="$satisfied_prereq$1 "
282 }
283 satisfied_prereq=" "
284 lazily_testable_prereq= lazily_tested_prereq=
285
286 # Usage: test_lazy_prereq PREREQ 'script'
287 test_lazy_prereq () {
288 lazily_testable_prereq="$lazily_testable_prereq$1 "
289 eval test_prereq_lazily_$1=\$2
290 }
291
292 test_run_lazy_prereq_ () {
293 script='
294 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
295 (
296 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
297 )'
298 say >&3 "checking prerequisite: $1"
299 say >&3 "$script"
300 test_eval_ "$script"
301 eval_ret=$?
302 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
303 if test "$eval_ret" = 0; then
304 say >&3 "prerequisite $1 ok"
305 else
306 say >&3 "prerequisite $1 not satisfied"
307 fi
308 return $eval_ret
309 }
310
311 test_have_prereq () {
312 # prerequisites can be concatenated with ','
313 save_IFS=$IFS
314 IFS=,
315 set -- $*
316 IFS=$save_IFS
317
318 total_prereq=0
319 ok_prereq=0
320 missing_prereq=
321
322 for prerequisite
323 do
324 case "$prerequisite" in
325 !*)
326 negative_prereq=t
327 prerequisite=${prerequisite#!}
328 ;;
329 *)
330 negative_prereq=
331 esac
332
333 case " $lazily_tested_prereq " in
334 *" $prerequisite "*)
335 ;;
336 *)
337 case " $lazily_testable_prereq " in
338 *" $prerequisite "*)
339 eval "script=\$test_prereq_lazily_$prerequisite" &&
340 if test_run_lazy_prereq_ "$prerequisite" "$script"
341 then
342 test_set_prereq $prerequisite
343 fi
344 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
345 esac
346 ;;
347 esac
348
349 total_prereq=$(($total_prereq + 1))
350 case "$satisfied_prereq" in
351 *" $prerequisite "*)
352 satisfied_this_prereq=t
353 ;;
354 *)
355 satisfied_this_prereq=
356 esac
357
358 case "$satisfied_this_prereq,$negative_prereq" in
359 t,|,t)
360 ok_prereq=$(($ok_prereq + 1))
361 ;;
362 *)
363 # Keep a list of missing prerequisites; restore
364 # the negative marker if necessary.
365 prerequisite=${negative_prereq:+!}$prerequisite
366 if test -z "$missing_prereq"
367 then
368 missing_prereq=$prerequisite
369 else
370 missing_prereq="$prerequisite,$missing_prereq"
371 fi
372 esac
373 done
374
375 test $total_prereq = $ok_prereq
376 }
377
378 test_declared_prereq () {
379 case ",$test_prereq," in
380 *,$1,*)
381 return 0
382 ;;
383 esac
384 return 1
385 }
386
387 test_verify_prereq () {
388 test -z "$test_prereq" ||
389 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
390 error "bug in the test script: '$test_prereq' does not look like a prereq"
391 }
392
393 test_expect_failure () {
394 test_start_
395 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
396 test "$#" = 2 ||
397 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
398 test_verify_prereq
399 export test_prereq
400 if ! test_skip "$@"
401 then
402 say >&3 "checking known breakage: $2"
403 if test_run_ "$2" expecting_failure
404 then
405 test_known_broken_ok_ "$1"
406 else
407 test_known_broken_failure_ "$1"
408 fi
409 fi
410 test_finish_
411 }
412
413 test_expect_success () {
414 test_start_
415 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
416 test "$#" = 2 ||
417 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
418 test_verify_prereq
419 export test_prereq
420 if ! test_skip "$@"
421 then
422 say >&3 "expecting success: $2"
423 if test_run_ "$2"
424 then
425 test_ok_ "$1"
426 else
427 test_failure_ "$@"
428 fi
429 fi
430 test_finish_
431 }
432
433 # test_external runs external test scripts that provide continuous
434 # test output about their progress, and succeeds/fails on
435 # zero/non-zero exit code. It outputs the test output on stdout even
436 # in non-verbose mode, and announces the external script with "# run
437 # <n>: ..." before running it. When providing relative paths, keep in
438 # mind that all scripts run in "trash directory".
439 # Usage: test_external description command arguments...
440 # Example: test_external 'Perl API' perl ../path/to/test.pl
441 test_external () {
442 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
443 test "$#" = 3 ||
444 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
445 descr="$1"
446 shift
447 test_verify_prereq
448 export test_prereq
449 if ! test_skip "$descr" "$@"
450 then
451 # Announce the script to reduce confusion about the
452 # test output that follows.
453 say_color "" "# run $test_count: $descr ($*)"
454 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
455 # to be able to use them in script
456 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
457 # Run command; redirect its stderr to &4 as in
458 # test_run_, but keep its stdout on our stdout even in
459 # non-verbose mode.
460 "$@" 2>&4
461 if test "$?" = 0
462 then
463 if test $test_external_has_tap -eq 0; then
464 test_ok_ "$descr"
465 else
466 say_color "" "# test_external test $descr was ok"
467 test_success=$(($test_success + 1))
468 fi
469 else
470 if test $test_external_has_tap -eq 0; then
471 test_failure_ "$descr" "$@"
472 else
473 say_color error "# test_external test $descr failed: $@"
474 test_failure=$(($test_failure + 1))
475 fi
476 fi
477 fi
478 }
479
480 # Like test_external, but in addition tests that the command generated
481 # no output on stderr.
482 test_external_without_stderr () {
483 # The temporary file has no (and must have no) security
484 # implications.
485 tmp=${TMPDIR:-/tmp}
486 stderr="$tmp/git-external-stderr.$$.tmp"
487 test_external "$@" 4> "$stderr"
488 test -f "$stderr" || error "Internal error: $stderr disappeared."
489 descr="no stderr: $1"
490 shift
491 say >&3 "# expecting no stderr from previous command"
492 if test ! -s "$stderr"
493 then
494 rm "$stderr"
495
496 if test $test_external_has_tap -eq 0; then
497 test_ok_ "$descr"
498 else
499 say_color "" "# test_external_without_stderr test $descr was ok"
500 test_success=$(($test_success + 1))
501 fi
502 else
503 if test "$verbose" = t
504 then
505 output=$(echo; echo "# Stderr is:"; cat "$stderr")
506 else
507 output=
508 fi
509 # rm first in case test_failure exits.
510 rm "$stderr"
511 if test $test_external_has_tap -eq 0; then
512 test_failure_ "$descr" "$@" "$output"
513 else
514 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
515 test_failure=$(($test_failure + 1))
516 fi
517 fi
518 }
519
520 # debugging-friendly alternatives to "test [-f|-d|-e]"
521 # The commands test the existence or non-existence of $1. $2 can be
522 # given to provide a more precise diagnosis.
523 test_path_is_file () {
524 if ! test -f "$1"
525 then
526 echo "File $1 doesn't exist. $2"
527 false
528 fi
529 }
530
531 test_path_is_dir () {
532 if ! test -d "$1"
533 then
534 echo "Directory $1 doesn't exist. $2"
535 false
536 fi
537 }
538
539 # Check if the directory exists and is empty as expected, barf otherwise.
540 test_dir_is_empty () {
541 test_path_is_dir "$1" &&
542 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
543 then
544 echo "Directory '$1' is not empty, it contains:"
545 ls -la "$1"
546 return 1
547 fi
548 }
549
550 test_path_is_missing () {
551 if test -e "$1"
552 then
553 echo "Path exists:"
554 ls -ld "$1"
555 if test $# -ge 1
556 then
557 echo "$*"
558 fi
559 false
560 fi
561 }
562
563 # test_line_count checks that a file has the number of lines it
564 # ought to. For example:
565 #
566 # test_expect_success 'produce exactly one line of output' '
567 # do something >output &&
568 # test_line_count = 1 output
569 # '
570 #
571 # is like "test $(wc -l <output) = 1" except that it passes the
572 # output through when the number of lines is wrong.
573
574 test_line_count () {
575 if test $# != 3
576 then
577 error "bug in the test script: not 3 parameters to test_line_count"
578 elif ! test $(wc -l <"$3") "$1" "$2"
579 then
580 echo "test_line_count: line count for $3 !$1 $2"
581 cat "$3"
582 return 1
583 fi
584 }
585
586 # Returns success if a comma separated string of keywords ($1) contains a
587 # given keyword ($2).
588 # Examples:
589 # `list_contains "foo,bar" bar` returns 0
590 # `list_contains "foo" bar` returns 1
591
592 list_contains () {
593 case ",$1," in
594 *,$2,*)
595 return 0
596 ;;
597 esac
598 return 1
599 }
600
601 # This is not among top-level (test_expect_success | test_expect_failure)
602 # but is a prefix that can be used in the test script, like:
603 #
604 # test_expect_success 'complain and die' '
605 # do something &&
606 # do something else &&
607 # test_must_fail git checkout ../outerspace
608 # '
609 #
610 # Writing this as "! git checkout ../outerspace" is wrong, because
611 # the failure could be due to a segv. We want a controlled failure.
612
613 test_must_fail () {
614 case "$1" in
615 ok=*)
616 _test_ok=${1#ok=}
617 shift
618 ;;
619 *)
620 _test_ok=
621 ;;
622 esac
623 "$@"
624 exit_code=$?
625 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
626 then
627 echo >&2 "test_must_fail: command succeeded: $*"
628 return 1
629 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
630 then
631 return 0
632 elif test $exit_code -gt 129 && test $exit_code -le 192
633 then
634 echo >&2 "test_must_fail: died by signal $(($exit_code - 128)): $*"
635 return 1
636 elif test $exit_code -eq 127
637 then
638 echo >&2 "test_must_fail: command not found: $*"
639 return 1
640 elif test $exit_code -eq 126
641 then
642 echo >&2 "test_must_fail: valgrind error: $*"
643 return 1
644 fi
645 return 0
646 }
647
648 # Similar to test_must_fail, but tolerates success, too. This is
649 # meant to be used in contexts like:
650 #
651 # test_expect_success 'some command works without configuration' '
652 # test_might_fail git config --unset all.configuration &&
653 # do something
654 # '
655 #
656 # Writing "git config --unset all.configuration || :" would be wrong,
657 # because we want to notice if it fails due to segv.
658
659 test_might_fail () {
660 test_must_fail ok=success "$@"
661 }
662
663 # Similar to test_must_fail and test_might_fail, but check that a
664 # given command exited with a given exit code. Meant to be used as:
665 #
666 # test_expect_success 'Merge with d/f conflicts' '
667 # test_expect_code 1 git merge "merge msg" B master
668 # '
669
670 test_expect_code () {
671 want_code=$1
672 shift
673 "$@"
674 exit_code=$?
675 if test $exit_code = $want_code
676 then
677 return 0
678 fi
679
680 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
681 return 1
682 }
683
684 # test_cmp is a helper function to compare actual and expected output.
685 # You can use it like:
686 #
687 # test_expect_success 'foo works' '
688 # echo expected >expected &&
689 # foo >actual &&
690 # test_cmp expected actual
691 # '
692 #
693 # This could be written as either "cmp" or "diff -u", but:
694 # - cmp's output is not nearly as easy to read as diff -u
695 # - not all diff versions understand "-u"
696
697 test_cmp() {
698 $GIT_TEST_CMP "$@"
699 }
700
701 # test_cmp_bin - helper to compare binary files
702
703 test_cmp_bin() {
704 cmp "$@"
705 }
706
707 # Call any command "$@" but be more verbose about its
708 # failure. This is handy for commands like "test" which do
709 # not output anything when they fail.
710 verbose () {
711 "$@" && return 0
712 echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
713 return 1
714 }
715
716 # Check if the file expected to be empty is indeed empty, and barfs
717 # otherwise.
718
719 test_must_be_empty () {
720 if test -s "$1"
721 then
722 echo "'$1' is not empty, it contains:"
723 cat "$1"
724 return 1
725 fi
726 }
727
728 # Tests that its two parameters refer to the same revision
729 test_cmp_rev () {
730 git rev-parse --verify "$1" >expect.rev &&
731 git rev-parse --verify "$2" >actual.rev &&
732 test_cmp expect.rev actual.rev
733 }
734
735 # Print a sequence of integers in increasing order, either with
736 # two arguments (start and end):
737 #
738 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
739 #
740 # or with one argument (end), in which case it starts counting
741 # from 1.
742
743 test_seq () {
744 case $# in
745 1) set 1 "$@" ;;
746 2) ;;
747 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
748 esac
749 test_seq_counter__=$1
750 while test "$test_seq_counter__" -le "$2"
751 do
752 echo "$test_seq_counter__"
753 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
754 done
755 }
756
757 # This function can be used to schedule some commands to be run
758 # unconditionally at the end of the test to restore sanity:
759 #
760 # test_expect_success 'test core.capslock' '
761 # git config core.capslock true &&
762 # test_when_finished "git config --unset core.capslock" &&
763 # hello world
764 # '
765 #
766 # That would be roughly equivalent to
767 #
768 # test_expect_success 'test core.capslock' '
769 # git config core.capslock true &&
770 # hello world
771 # git config --unset core.capslock
772 # '
773 #
774 # except that the greeting and config --unset must both succeed for
775 # the test to pass.
776 #
777 # Note that under --immediate mode, no clean-up is done to help diagnose
778 # what went wrong.
779
780 test_when_finished () {
781 # We cannot detect when we are in a subshell in general, but by
782 # doing so on Bash is better than nothing (the test will
783 # silently pass on other shells).
784 test "${BASH_SUBSHELL-0}" = 0 ||
785 error "bug in test script: test_when_finished does nothing in a subshell"
786 test_cleanup="{ $*
787 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
788 }
789
790 # Most tests can use the created repository, but some may need to create more.
791 # Usage: test_create_repo <directory>
792 test_create_repo () {
793 test "$#" = 1 ||
794 error "bug in the test script: not 1 parameter to test-create-repo"
795 repo="$1"
796 mkdir -p "$repo"
797 (
798 cd "$repo" || error "Cannot setup test environment"
799 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
800 error "cannot run git init -- have you built things yet?"
801 mv .git/hooks .git/hooks-disabled
802 ) || exit
803 }
804
805 # This function helps on symlink challenged file systems when it is not
806 # important that the file system entry is a symbolic link.
807 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
808 # symbolic link entry y to the index.
809
810 test_ln_s_add () {
811 if test_have_prereq SYMLINKS
812 then
813 ln -s "$1" "$2" &&
814 git update-index --add "$2"
815 else
816 printf '%s' "$1" >"$2" &&
817 ln_s_obj=$(git hash-object -w "$2") &&
818 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
819 # pick up stat info from the file
820 git update-index "$2"
821 fi
822 }
823
824 # This function writes out its parameters, one per line
825 test_write_lines () {
826 printf "%s\n" "$@"
827 }
828
829 perl () {
830 command "$PERL_PATH" "$@"
831 }
832
833 # Is the value one of the various ways to spell a boolean true/false?
834 test_normalize_bool () {
835 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
836 }
837
838 # Given a variable $1, normalize the value of it to one of "true",
839 # "false", or "auto" and store the result to it.
840 #
841 # test_tristate GIT_TEST_HTTPD
842 #
843 # A variable set to an empty string is set to 'false'.
844 # A variable set to 'false' or 'auto' keeps its value.
845 # Anything else is set to 'true'.
846 # An unset variable defaults to 'auto'.
847 #
848 # The last rule is to allow people to set the variable to an empty
849 # string and export it to decline testing the particular feature
850 # for versions both before and after this change. We used to treat
851 # both unset and empty variable as a signal for "do not test" and
852 # took any non-empty string as "please test".
853
854 test_tristate () {
855 if eval "test x\"\${$1+isset}\" = xisset"
856 then
857 # explicitly set
858 eval "
859 case \"\$$1\" in
860 '') $1=false ;;
861 auto) ;;
862 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
863 esac
864 "
865 else
866 eval "$1=auto"
867 fi
868 }
869
870 # Exit the test suite, either by skipping all remaining tests or by
871 # exiting with an error. If "$1" is "auto", we then we assume we were
872 # opportunistically trying to set up some tests and we skip. If it is
873 # "true", then we report a failure.
874 #
875 # The error/skip message should be given by $2.
876 #
877 test_skip_or_die () {
878 case "$1" in
879 auto)
880 skip_all=$2
881 test_done
882 ;;
883 true)
884 error "$2"
885 ;;
886 *)
887 error "BUG: test tristate is '$1' (real error: $2)"
888 esac
889 }
890
891 # The following mingw_* functions obey POSIX shell syntax, but are actually
892 # bash scripts, and are meant to be used only with bash on Windows.
893
894 # A test_cmp function that treats LF and CRLF equal and avoids to fork
895 # diff when possible.
896 mingw_test_cmp () {
897 # Read text into shell variables and compare them. If the results
898 # are different, use regular diff to report the difference.
899 local test_cmp_a= test_cmp_b=
900
901 # When text came from stdin (one argument is '-') we must feed it
902 # to diff.
903 local stdin_for_diff=
904
905 # Since it is difficult to detect the difference between an
906 # empty input file and a failure to read the files, we go straight
907 # to diff if one of the inputs is empty.
908 if test -s "$1" && test -s "$2"
909 then
910 # regular case: both files non-empty
911 mingw_read_file_strip_cr_ test_cmp_a <"$1"
912 mingw_read_file_strip_cr_ test_cmp_b <"$2"
913 elif test -s "$1" && test "$2" = -
914 then
915 # read 2nd file from stdin
916 mingw_read_file_strip_cr_ test_cmp_a <"$1"
917 mingw_read_file_strip_cr_ test_cmp_b
918 stdin_for_diff='<<<"$test_cmp_b"'
919 elif test "$1" = - && test -s "$2"
920 then
921 # read 1st file from stdin
922 mingw_read_file_strip_cr_ test_cmp_a
923 mingw_read_file_strip_cr_ test_cmp_b <"$2"
924 stdin_for_diff='<<<"$test_cmp_a"'
925 fi
926 test -n "$test_cmp_a" &&
927 test -n "$test_cmp_b" &&
928 test "$test_cmp_a" = "$test_cmp_b" ||
929 eval "diff -u \"\$@\" $stdin_for_diff"
930 }
931
932 # $1 is the name of the shell variable to fill in
933 mingw_read_file_strip_cr_ () {
934 # Read line-wise using LF as the line separator
935 # and use IFS to strip CR.
936 local line
937 while :
938 do
939 if IFS=$'\r' read -r -d $'\n' line
940 then
941 # good
942 line=$line$'\n'
943 else
944 # we get here at EOF, but also if the last line
945 # was not terminated by LF; in the latter case,
946 # some text was read
947 if test -z "$line"
948 then
949 # EOF, really
950 break
951 fi
952 fi
953 eval "$1=\$$1\$line"
954 done
955 }
956
957 # Like "env FOO=BAR some-program", but run inside a subshell, which means
958 # it also works for shell functions (though those functions cannot impact
959 # the environment outside of the test_env invocation).
960 test_env () {
961 (
962 while test $# -gt 0
963 do
964 case "$1" in
965 *=*)
966 eval "${1%%=*}=\${1#*=}"
967 eval "export ${1%%=*}"
968 shift
969 ;;
970 *)
971 "$@"
972 exit
973 ;;
974 esac
975 done
976 )
977 }
978
979 # Returns true if the numeric exit code in "$2" represents the expected signal
980 # in "$1". Signals should be given numerically.
981 test_match_signal () {
982 if test "$2" = "$((128 + $1))"
983 then
984 # POSIX
985 return 0
986 elif test "$2" = "$((256 + $1))"
987 then
988 # ksh
989 return 0
990 fi
991 return 1
992 }
993
994 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
995 test_copy_bytes () {
996 perl -e '
997 my $len = $ARGV[1];
998 while ($len > 0) {
999 my $s;
1000 my $nread = sysread(STDIN, $s, $len);
1001 die "cannot read: $!" unless defined($nread);
1002 print $s;
1003 $len -= $nread;
1004 }
1005 ' - "$1"
1006 }